Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -3611,30 +4509,11 @@
         ValueConvInv => '$val + 1',
     },
-    0x1a7 => { #(NC)
-        Name => 'DirectoryIndex',
-        Condition => '$$self{CanonFirmB}',
-        Groups => { 2 => 'Image' },
-        Format => 'int32u',
-        ValueConv => '$val - 1',
-        ValueConvInv => '$val + 1',
-    },
-    0x2d3 => {
-        Name => 'PictureStyleInfo',
-        Condition => '$$self{CanonFirmA}',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
-    },
     0x2d7 => {
         Name => 'PictureStyleInfo',
-        Condition => '$$self{CanonFirmB}',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
-    },
-);
-
-# Canon camera information for 60D (MakerNotes tag 0x0d)
-# (ref PH unless otherwise noted)
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
+    },
+);
+
+# Canon camera information for 60D/1200D (MakerNotes tag 0x0d) (ref PH)
 # NOTE: Can probably borrow more 50D tags here, possibly with an offset
 %Image::ExifTool::Canon::CameraInfo60D = (
@@ -3643,8 +4522,7 @@
     FIRST_ENTRY => 0,
     PRIORITY => 0,
-  #  DATAMEMBER => [ 0x199 ],
-    IS_SUBDIR => [ 0x321 ],
+    IS_SUBDIR => [ 0x2f9, 0x321 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'CameraInfo tags for the EOS 60D.',
+    NOTES => 'CameraInfo tags for the EOS 60D and 1200D.',
     0x03 => { %ciFNumber },
     0x04 => { %ciExposureTime },
@@ -3654,4 +4532,6 @@
     0x36 => {
         Name => 'CameraOrientation',
+        Condition => '$$self{Model} =~ /EOS 60D$/', #(NC)
+        Notes => '60D only',
         PrintConv => {
             0 => 'Horizontal (normal)',
@@ -3660,14 +4540,30 @@
         },
     },
+    0x3a => { #IB
+        Name => 'CameraOrientation',
+        Condition => '$$self{Model} =~ /\b(1200D|REBEL T5|Kiss X70)\b/',
+        Notes => '1200D only',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
     0x55 => {
         Name => 'FocusDistanceUpper',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D only',
         %focusDistanceByteSwap,
     },
     0x57 => {
         Name => 'FocusDistanceLower',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D only',
         %focusDistanceByteSwap,
     },
     0x7d => {
         Name => 'ColorTemperature',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D only',
         Format => 'int16u',
     },
@@ -3676,16 +4572,96 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xea => { %ciShortFocal },
-    0xec => { %ciLongFocal },
-    0x199 => {
+    0xea => { %ciMinFocal },
+    0xec => { %ciMaxFocal },
+    0x199 => {  # (at this location for 60D firmware 2.8.1/1.0.5, and 1200D 3.3.1/1.0.0)
         Name => 'FirmwareVersion',
         Format => 'string[6]',
-  #      Notes => 'at this location for firmware 2.8.1 and 1.0.5',
         Writable => 0,
-  #      RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $$self{CanonFirmA}=$val : undef',
     },
     0x1d9 => {
+        Name => 'FileIndex',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D only',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x1e5 => { #(NC)
+        Name => 'DirectoryIndex',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D only',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x2f9 => {
+        Name => 'PictureStyleInfo',
+        Condition => '$$self{Model} =~ /\b(1200D|REBEL T5|Kiss X70)\b/',
+        Notes => '1200D',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+    0x321 => {
+        Name => 'PictureStyleInfo',
+        Condition => '$$self{Model} =~ /EOS 60D$/',
+        Notes => '60D',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+);
+
+# Canon camera information for 70D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo70D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    IS_SUBDIR => [ 0x3cf ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 70D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature },
+    0x23 => { %ciFocalLength },
+    # 0x36 - focal length again?
+    0x84 => {
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x93 => {
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x95 => {
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0xc7 => {
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0x166 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x168 => { %ciMinFocal },
+    0x16a => { %ciMaxFocal },
+    0x25e => {  # (at this location for firmware 6.1.2, 1.0.4 and 1.1.1)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+    },
+    0x2b3 => {
         Name => 'FileIndex',
         Groups => { 2 => 'Image' },
@@ -3694,5 +4670,5 @@
         ValueConvInv => '$val - 1',
     },
-    0x1e5 => { #(NC)
+    0x2bf => { #(NC)
         Name => 'DirectoryIndex',
         Groups => { 2 => 'Image' },
@@ -3701,9 +4677,70 @@
         ValueConvInv => '$val + 1',
     },
-    0x321 => {
-        Name => 'PictureStyleInfo2',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo2',
-        },
+    0x3cf => { #48
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+);
+
+# Canon camera information for 80D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo80D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 80D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature },
+    0x23 => { %ciFocalLength },
+    0x96 => {
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0xa5 => {
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0xa7 => {
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0x13a => {
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0x189 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x18b => { %ciMinFocal },
+    0x18d => { %ciMaxFocal },
+    0x45a => {  # (at this location for firmware 1.0.1)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+    },
+    0x4ae => {
+        Name => 'FileIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x4ba => { #(NC)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
     },
 );
@@ -3766,4 +4803,5 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
@@ -3790,7 +4828,5 @@
     0x263 => { #PH
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
     0x933 => { #33
@@ -3814,5 +4850,5 @@
     0x07 => {
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x15 => { #PH (580 EX II)
@@ -3882,8 +4918,9 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xf8 => { %ciShortFocal },
-    0xfa => { %ciLongFocal },
+    0xf8 => { %ciMinFocal },
+    0xfa => { %ciMaxFocal },
     0x190 => {
         Name => 'FirmwareVersion',
@@ -3908,7 +4945,5 @@
     0x30b => {
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
 );
@@ -3928,5 +4963,5 @@
     0x07 => { #(NC)
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x15 => { #(NC)
@@ -3978,8 +5013,9 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0x101 => { %ciShortFocal }, # (500D + 9)
-    0x103 => { %ciLongFocal }, # (500D + 9)
+    0x101 => { %ciMinFocal }, # (500D + 9)
+    0x103 => { %ciMaxFocal }, # (500D + 9)
     0x1a4 => { # (500D + 0x11)
         Name => 'FirmwareVersion',
@@ -4004,7 +5040,282 @@
     0x31c => { #48
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
+    },
+);
+
+# Canon camera information for 600D and 1100D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo600D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    IS_SUBDIR => [ 0x2fb ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 600D and 1100D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x07 => { #(NC)
+        Name => 'HighlightTonePriority',
+        PrintConv => \%offOn,
+    },
+    0x15 => { #(NC)
+        Name => 'FlashMeteringMode',
+        PrintConv => {
+            0 => 'E-TTL',
+            3 => 'TTL',
+            4 => 'External Auto',
+            5 => 'External Manual',
+            6 => 'Off',
+        },
+    },
+    0x19 => { %ciCameraTemperature }, # (60D + 0)
+    0x1e => { %ciFocalLength }, # (60D + 0)
+    0x38 => { # (60D + 2)
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x57 => { # (60D + 2, 550D + 3)
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x59 => { # (60D + 2, 550D + 3)
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0x7b => { # (550D + 3)
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0x7f => { # (60D + 2, 550D + 3)
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0xb3 => { # (550D + 3)
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0xea => { # (60D + 2, 550D + 3)
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0xec => { %ciMinFocal }, # (60D + 2)
+    0xee => { %ciMaxFocal }, # (60D + 2)
+    0x19b => { # (60D + 2)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
+    },
+    0x1db => { # (60D + 2) (NC)
+        Name => 'FileIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x1e7 => { # (60D + 2) (NC)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x2fb => {
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+);
+
+# Canon camera information for 650D/700D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo650D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    IS_SUBDIR => [ 0x390 ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 650D and 700D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature }, # (1DX/5DmkIII + 0)
+    0x23 => { %ciFocalLength }, # (1DX/5DmkIII + 3)
+    # 0x35 - seems to be the same as 0x54
+    0x7d => { # (1DX/5DmkIII + 3)
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x8c => { # (1DX + 3)
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x8e => { # (1DX + 3)
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0xbc => { # (1DX + 7)
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0xc0 => { # (1DX + 7)
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0xf4 => { # (1DX + 7)
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0x127 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x129 => { %ciMinFocal },
+    0x12b => { %ciMaxFocal },
+    0x21b => { # (650D version 1.0.1)
+        Name => 'FirmwareVersion',
+        Condition => '$$self{Model} =~ /(650D|REBEL T4i|Kiss X6i)\b/',
+        Notes => '650D',
+        Format => 'string[6]',
+        Writable => 0,
+        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
+    },
+    0x220 => { # (700D version 1.1.1/2.1.1)
+        Name => 'FirmwareVersion',
+        Condition => '$$self{Model} =~ /(700D|REBEL T5i|Kiss X7i)\b/',
+        Notes => '700D',
+        Format => 'string[6]',
+        Writable => 0,
+        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
+    },
+    0x270 => { #(NC)
+        Name => 'FileIndex',
+        Condition => '$$self{Model} =~ /(650D|REBEL T4i|Kiss X6i)\b/',
+        Notes => '650D',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x274 => { #(NC)
+        Name => 'FileIndex',
+        Condition => '$$self{Model} =~ /(700D|REBEL T5i|Kiss X7i)\b/',
+        Notes => '700D',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x27c => { #(NC)
+        Name => 'DirectoryIndex',
+        Condition => '$$self{Model} =~ /(650D|REBEL T4i|Kiss X6i)\b/',
+        Notes => '650D',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x280 => { #(NC)
+        Name => 'DirectoryIndex',
+        Condition => '$$self{Model} =~ /(700D|REBEL T5i|Kiss X7i)\b/',
+        Notes => '700D',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x390 => {
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+);
+
+# Canon camera information for 750D/760D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo750D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 750D and 760D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature }, # (700D + 0)
+    0x23 => { %ciFocalLength }, # (700D + 0)
+    0x96 => { #IB (700D + 0x19)
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0xa5 => { # (700D + 0x19)
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0xa7 => { # (700D + 0x19)
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0x131 => { # (700D + 0x19)
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0x135 => {
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0x169 => {
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0x184 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x186 => { %ciMinFocal },
+    0x188 => { %ciMaxFocal },
+    0x43d => { # (750D/760D firmware 6.7.2)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
+    },
+    0x449 => { # (750D/760D firmware 1.0.0)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
     },
 );
@@ -4065,6 +5376,9 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
+    0xe4 => { %ciMinFocal }, #PH
+    0xe6 => { %ciMaxFocal }, #PH
     0x10b => { #PH
         Name => 'FirmwareVersion',
@@ -4085,7 +5399,5 @@
     0x267 => { #PH
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
     0x937 => { #PH
@@ -4242,4 +5554,10 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     NOTES => 'Unknown CameraInfo tags are divided into 3 tables based on format size.',
+    # This tag may be uncommented, and is useful for generating
+    # lists of models in the "Notes" below...
+    # 0 => {
+    #     Name => 'CameraInfoCount',
+    #     ValueConv => '$$self{CameraInfoCount}',
+    # },
     71 => { # [-1] <-- index relative to CameraInfoCount
         Name => 'CameraTemperature',
@@ -4277,25 +5595,88 @@
         PrintConvInv => '$val=~s/ ?C//; $val',
     },
-    466 => { # [-3]
+    -3 => {
         Name => 'CameraTemperature',
-        Condition => '$$self{CameraInfoCount} == 469',
-        Notes => 'A1200, A2200, A3200, A3300, 100HS, 300HS and 500HS',
+        Condition => '$$self{CameraInfoCount} > 400',
+        Notes => '3 entries from end of record for most newer camera models',
         PrintConv => '"$val C"',
         PrintConvInv => '$val=~s/ ?C//; $val',
     },
-    503 => { # [-3]
-        Name => 'CameraTemperature',
-        Condition => '$$self{CameraInfoCount} == 506',
-        Notes => 'A800',
-        PrintConv => '"$val C"',
-        PrintConvInv => '$val=~s/ ?C//; $val',
-    },
-    506 => { # [-3]
-        Name => 'CameraTemperature',
-        Condition => '$$self{CameraInfoCount} == 509',
-        Notes => 'SX230HS',
-        PrintConv => '"$val C"',
-        PrintConvInv => '$val=~s/ ?C//; $val',
-    },
+#    466 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 469',
+#        Notes => '100HS, 300HS, 500HS, A1200, A2200, A3200 and A3300',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    503 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 506',
+#        Notes => 'A800',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    506 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 509',
+#        Notes => 'SX230HS',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    520 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 523',
+#        Notes => '310HS, 510HS, G1X, S100 (new), SX40HS and SX150',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    524 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 527',
+#        Notes => '110HS, 520HS, A2300, A2400, A3400, A4000, D20 and SX260HS',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    532 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 535',
+#        Notes => 'S110 (new), G15, SX50, SX160IS and SX500IS',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    547 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 550',
+#        Notes => '130IS, A1400, A2500 and A2600',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    549 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 552',
+#        Notes => '115IS, 130IS, SX270, SX280, 330HS and A3500',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    552 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 555',
+#        Notes => 'S200 (new)',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    850 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 853',
+#        Notes => 'N',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
+#    895 => { # [-3]
+#        Name => 'CameraTemperature',
+#        Condition => '$$self{CameraInfoCount} == 898',
+#        Notes => 'G1XmkII, N100, SX600HS and SX700HS',
+#        PrintConv => '"$val C"',
+#        PrintConvInv => '$val=~s/ ?C//; $val',
+#    },
 );
 
@@ -4316,4 +5697,19 @@
     PRIORITY => 0,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x16b => {
+        Name => 'LensSerialNumber',
+        Condition => '$$self{Model} =~ /^Canon EOS 5DS/', # (good for 5DS and 5DSR)
+        Format => 'undef[5]',
+        Priority => 0,
+        ValueConv => 'unpack("H*",$val)',
+        ValueConvInv => 'length($val) < 10 and $val = 0 x (10-length($val)) . $val; pack("H*",$val)',
+    },
+    0x5c1 => {
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+        Condition => '$$valPt =~ /^\d\.\d\.\d\0/',
+        Notes => 'M50', # (firmware 1.0.0)
+    },
 );
 
@@ -4473,5 +5869,5 @@
 );
 
-# Picture Style information for the 60D (ref 48)
+# Picture Style information for the 60D, etc (ref 48)
 %Image::ExifTool::Canon::PSInfo2 = (
     %binaryDataAttrs,
@@ -4479,5 +5875,5 @@
     PRIORITY => 0,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'Custom picture style information for the EOS 60D.',
+    NOTES => 'Custom picture style information for the EOS 5DmkIII, 60D, 600D and 1100D.',
     # (values expected to be "n/a" are flagged as Unknown)
     0x00 => { Name => 'ContrastStandard',      %psInfo },
@@ -4535,9 +5931,9 @@
         },
     },
-    0x90 => { Name => 'ContrastUnknown',        %psInfo, Unknown => 1 },
-    0x94 => { Name => 'SharpnessUnknown',       %psInfo, Unknown => 1 },
-    0x98 => { Name => 'SaturationUnknown',      %psInfo, Unknown => 1 },
-    0x9c => { Name => 'ColorToneUnknown',       %psInfo, Unknown => 1 },
-    0xa0 => { Name => 'FilterEffectUnknown',    %psInfo, Unknown => 1,
+    0x90 => { Name => 'ContrastAuto',          %psInfo },
+    0x94 => { Name => 'SharpnessAuto',         %psInfo },
+    0x98 => { Name => 'SaturationAuto',        %psInfo },
+    0x9c => { Name => 'ColorToneAuto',         %psInfo },
+    0xa0 => { Name => 'FilterEffectAuto',      %psInfo,
         PrintConv => {
             0 => 'None',
@@ -4549,5 +5945,5 @@
         },
     },
-    0xa4 => { Name => 'ToningEffectUnknown',    %psInfo, Unknown => 1,
+    0xa4 => { Name => 'ToningEffectAuto',      %psInfo,
         PrintConv => {
             0 => 'None',
@@ -4796,5 +6192,5 @@
 );
 
-# newer AF information (MakerNotes tag 0x26) - PH (A570IS,1DmkIII,40D)
+# newer AF information (MakerNotes tag 0x26 and 0x32) - PH (A570IS,1DmkIII,40D and G1XmkII)
 # (Note: this tag is out of sequence in A570IS maker notes)
 %Image::ExifTool::Canon::AFInfo2 = (
@@ -4805,6 +6201,6 @@
     NOTES => q{
         Newer version of the AFInfo record containing much of the same information
-        (and coordinate confusion) as the older version.  In this record, values of
-        9 and 45 have been observed for NumAFPoints.
+        (and coordinate confusion) as the older version.  In this record, NumAFPoints
+        may be 7, 9, 11, 19, 31, 45 or 61, depending on the camera model.
     },
     0 => {
@@ -4816,10 +6212,18 @@
         PrintConv => {
             0 => 'Off (Manual Focus)',
+            1 => 'AF Point Expansion (surround)', #PH
             2 => 'Single-point AF',
-            4 => 'Multi-point AF or AI AF', # AiAF on A570IS
+            # 3 - n/a
+            4 => 'Auto', #forum6237 (AiAF on A570IS)
             5 => 'Face Detect AF',
+            6 => 'Face + Tracking', #PH (NC, EOS M, live view)
             7 => 'Zone AF', #46
-            8 => 'AF Point Expansion', #46
+            8 => 'AF Point Expansion (4 point)', #46/PH/forum6237
             9 => 'Spot AF', #46
+            10 => 'AF Point Expansion (8 point)', #forum6237
+            11 => 'Flexizone Multi (49 point)', #PH (NC, EOS M, live view; 750D 49 points)
+            12 => 'Flexizone Multi (9 point)', #PH (750D, 9 points)
+            13 => 'Flexizone Single', #PH (EOS M default, live view)
+            14 => 'Large Zone AF', #PH/forum6237 (7DmkII)
         },
     },
